# Migrating from 9.x.x to 10.x.x

## Major changes

It's fast - very fast! The Ruby shared core has been replaced by the [Rust shared core](https://github.com/pact-foundation/pact-reference/tree/master/rust/).

1. Ability to create and verify both [v2] and [v3] [specification] pacts
2. A bunch of new features, including the new v3 specification [matchers and generators](https://github.com/pact-foundation/pact-specification/tree/version-3/), XML support, binary payloads, injected provider states and more.
3. Each test is given a dedicated server and port, simplifying lifecycle events and improving isolation between tests, also allowing the possibility of parallel tests if needed (but, you probably don't)

## Breaking changes


### Consumer

* The undocumented Monkey patching support no longer exists (there is no Ruby to monkeypatch!)
* Removed public `json()` method from consumer message pact
* `pactfileWriteMode` still supports the same options, however the behaviour of `overwrite` is such now that it will overwrite the pact file _per test_, not pact run of Pact. This is because there is no longer a single long running mock server as per previous versions. Set to `merge` or leave blank for a sensible default. 
* As per the change to `pactfileWriteMode` this also means pact files should be cleared out prior to each test, to avoid extraneous interactions in a pact file.
* Array matcher currently doesn't work on query strings (see https://github.com/pact-foundation/pact-reference/issues/205). However, an array with matchers is supported (see jest spec) which can be used as a workarounnd
* the `mockService` property on the `Pact` class is no longer an actual `MockService`, but supports the `baseUrl` property.
* Manually controlling the state of the mock server - such as removing interactions - has been removed.
* There is currently no support for specifying custom tls certificates in consumer Pact tests
* `Publisher` has been removed in favour of encouraging usage of the [CLI].

### Provider

N/A

### Messages

N/A - However, you can now validate your metadata too!

## Basic migration

## Consumer

[CLI](https://docs.pact.io/implementation_guides/cli/)
[v2](https://github.com/pact-foundation/pact-specification/tree/version-3/)
[v3](https://github.com/pact-foundation/pact-specification/tree/version-2/)
[specification](https://github.com/pact-foundation/pact-specification/)
[parameters](https://github.com/pact-foundation/pact-specification/tree/version-3/#allow-multiple-provider-states-with-parameters)

